--[[
****************************************************************************************
Chuck Norris Facts

$Date: 2008-08-02 20:57:00 -0400 (Sat, 02 Aug 2008) $
$Rev: 79697 $

****************************************************************************************

Please see Wowace.com for more information.

****************************************************************************************
]]

CNF 		= LibStub("AceAddon-3.0"):NewAddon("Chuck Norris Facts", "AceConsole-3.0")

local addon = CNF

local random = math.random
local GetGameTime = GetGameTime

-- Spam protection
local lastminute

-- Returns configuration options for ARL
local function giveCNFOptions()

	local command_options = {
	    type = "group",
	    args =
		{
			header1 =
			{
				order = 1,
				type = "header",
				name = "",
			},
			displayself = 
			{
				type = "execute",
				name = "Display Fact (Self)",
				desc = "Displays a random Chuck Norris fact to yourself.",
				func = function(info) addon:Print(addon:GetCNF()) end,
				order = 5,
			},
			displaysay = 
			{
				type = "execute",
				name = "Display Fact (Say)",
				desc = "Displays a random Chuck Norris fact in say.",
				func = function(info) addon:DisplayCNF("SAY") end,
				order = 6,
			},
			displayguild = 
			{
				type = "execute",
				name = "Display Fact (Guild)",
				desc = "Displays a random Chuck Norris fact in guild.",
				func = function(info) addon:DisplayCNF("GUILD") end,
				order = 7,
			},
			displayparty = 
			{
				type = "execute",
				name = "Display Fact (Party)",
				desc = "Displays a random Chuck Norris fact in party.",
				func = function(info) addon:DisplayCNF("PARTY") end,
				order = 8,
			},
			displayraid = 
			{
				type = "execute",
				name = "Display Fact (Raid)",
				desc = "Displays a random Chuck Norris fact in raid.",
				func = function(info) addon:DisplayCNF("RAID") end,
				order = 9,
			},
		}
	}

	return command_options

end

function addon:OnInitialize()

	local AceConfigReg = LibStub("AceConfigRegistry-3.0")
	local AceConfigDialog = LibStub("AceConfigDialog-3.0")

	-- Create the options with Ace3
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Chuck Norris Facts",giveCNFOptions,"Chuck Norris Facts")

	-- Add the options to blizzard frame (add them backwards so they show up in the proper order
	self.optionsFrame = AceConfigDialog:AddToBlizOptions("Chuck Norris Facts","Chuck Norris Facts")
	self.optionsFrame["About"] = LibStub("LibAboutPanel").new("Chuck Norris Facts", "CNF")

	self:RegisterChatCommand("chuck", "ChatCommandHandler")

end

-- Gets a random quote from the database and returns it.

function addon:GetCNF()

	return addon.CNFDB[random(#addon.CNFDB)]

end

-- Outputs a chuck norris fact to the specified channel.  Does spam checking

function addon:DisplayCNF(channel)

	local _,minute = GetGameTime()
	-- If there is 1 or more minutes since the last time we did this or if it's the first time
	if ((not lastminute) or ((minute - lastminute) > 0) or (abs((minute - lastminute)) > 0)) then
		-- Update the time
		lastminute = minute
		SendChatMessage(self:GetCNF(), channel)
	else
		self:Print("You have displayed a Chuck Norris Fact within the last minute, please wait before doing it again.")
	end

end

-- Slash command handler

function addon:ChatCommandHandler(input)

	if (not input) or (input and input:trim() == "") then
		self:Print(self:GetCNF())
	elseif (input == string.lower("Say")) then
		addon:DisplayCNF("SAY")
	elseif (input == string.lower("Guild")) then
		addon:DisplayCNF("GUILD")
	elseif (input == string.lower("Party")) then
		addon:DisplayCNF("PARTY")
	elseif (input == string.lower("Raid")) then
		addon:DisplayCNF("RAID")
	end

end
